/************************************************************

    RezParse.h
    C Interface to Rez Parser

     Copyright Evatac Software  1988-1995
    All rights reserved

************************************************************/

#ifndef __REZPARSERH__
#define __REZPARSERH__

#include "LanguageModule.h"

/*
 * * * * * * * * * CONSTANTS AND MACRO DEFINITIONS * * * * * * * * * *
 */

/* 
 * Here are the token types we return
 */

enum {
	kDefinition,
	kKeyword,
	kComment,
	kCustomKeyword
};

enum {
    kSymbolLeftParen		= '(',	/* ( */
    kSymbolRightParen		= ')',	/* ) */
    kSymbolLeftHard			= '[',	/* [ */
    kSymbolRightHard		= ']',	/* ] */
    kSymbolLeftBrace	    = '{',	/* { */
    kSymbolRightBrace		= '}',	/* } */
    kSymbolBackSlash		= '\\',	/* \ */
    kSymbolQuote	 		= '\'',	/* ' */
    kSymbolDoubleQuote		= '\"',	/* " */
    kSymbolPound			= '#',	/* # */
    kSymbolSemiColon		= ';',	/* ; */
    kSymbolCommon			= ',',	/* , */
    kSymbolDot				= '.',	/* . */
    kSymbolColon			= ':',	/* : */
    kSymbolAssign			= '=',	/* = */
    kSymbolNot				= '!',	/* ! */
    kSymbolMod				= '%',	/* % */
    kSymbolXOr				= '^',	/* ^ */
    kSymbolAnd				= '&',	/* & */
    kSymbolStar				= '*',	/* * */
    kSymbolMinus			= '-',	/* - */
    kSymbolPlus				= '+',	/* + */
    kSymbolBar				= '|',	/* | */
    kSymbolComplement		= '~',	/* ~ */
    kSymbolLess				= '<',	/* < */
    kSymbolGreater			= '>',	/* > */
    kSymbolQuestion			= '?',	/* ? */
    kSymbolDivide			= '/',	/* / */

    kSymbolFirstCompoundSymbol = 300,
    kSymbolArray = 300,				/* $$ */
	kSymbolLastCompoundSymbol,

	kSymbolFirstSpecial = 400,
	kSymbolIdentifier = 400,
	kSymbolIntConstant,
	kSymbolCharConstant,
	kSymbolFloatConstant,
	kSymbolStringLiteral,
	kSymbolWhiteSpace,
	kSymbolComment,
	kSymbolPreprocessorDirective,
	kSymbolInclude,
	kSymbolLastSpecial,

	kSymbolReservedWord = 500,
	kSymbolCustomWord
};

/*
 * * * * * * * * * TYPE AND STRUCTURE DEFINITIONS * * * * * * * * * *
 */

/*
 * * * * * * * * * FUNCTION PROTOTYPES * * * * * * * * * *
 */

/*
 * * * * * * * * * FUNCTIONS IMPLEMENTED AS MACROS * * * * * * * *
 */


#endif

